MODULE Stack ;

TYPE Index = [0..Capacity] ;

VAR store : ARRAY Index OF Item ;
    top   : Index ;


PROCEDURE Push(item : Item) =
BEGIN 
    <* ASSERT NOT IsFull() *>
    store[top] := item ;
    INC(top) ;
END Push ;


PROCEDURE Pop() : Item =
BEGIN
    <* ASSERT NOT IsEmpty() *>
    DEC(top) ;
    RETURN store[top] ;
END Pop ;


PROCEDURE IsFull() : BOOLEAN =
BEGIN
    RETURN top > Capacity ;
END IsFull ;


PROCEDURE IsEmpty() : BOOLEAN =
BEGIN
    RETURN top <= 0 ;
END IsEmpty ;


BEGIN
    top := 0 ;
END Stack .
