(* Aufg. 12: Maximale Teilfolge *)

MODULE MaxSubSeq EXPORTS Main;
IMPORT IO;

CONST Nmax=28;

TYPE Array = ARRAY[1..Nmax] OF INTEGER;

VAR seq : Array;


PROCEDURE InitSeq(VAR a : Array) =
BEGIN
  a[ 1] :=   18; a[ 2] :=   -5; a[ 3] :=   -8; a[ 4] :=   -3;
  a[ 5] :=  121; a[ 6] :=  -30; a[ 7] :=  100; a[ 8] :=  -89; 
  a[ 9] :=   20; a[10] := -100; a[11] :=   10; a[12] :=  105; 
  a[13] :=  -34; a[14] :=    2; a[15] := -105; a[16] :=  200; 
  a[17] :=  300; a[18] := -611; a[19] :=  500; a[20] := -222; 
  a[21] := -299; a[22] := -495; a[23] := -125; a[24] :=  501; 
  a[25] := -798; a[26] :=  -30; a[27] :=  450; a[28] :=   13; 
END InitSeq;


PROCEDURE CalcMaxSubSeq(READONLY a : Array) : INTEGER =
VAR max, pos_sum, neg_sum : INTEGER;
    k, fst, lst, fst_idx, lst_idx : CARDINAL;
BEGIN
  max := 0;
  pos_sum := 0;
  neg_sum := 0;

  fst := 0;
  lst := 0;
  fst_idx := FIRST(a);
  lst_idx := 0;

  k := FIRST(a);
  WHILE k<=LAST(a) DO

    WHILE k<=LAST(a) AND a[k]>=0 DO
      pos_sum := pos_sum + a[k];
      lst_idx := k;
      INC(k);
    END;

    IF max<pos_sum
      THEN max := pos_sum;
           fst := fst_idx;
           lst := lst_idx;
    END;

    WHILE k<=LAST(a) AND a[k]<0 DO
      neg_sum := neg_sum + a[k];
      lst_idx := k;
      INC(k);
    END;

    IF pos_sum+neg_sum>0
      THEN pos_sum := pos_sum + neg_sum;
      ELSE pos_sum := 0; fst_idx := k;
    END;

    neg_sum := 0;

  END;

  IO.Put("S_a(i=");
  IO.PutInt(fst);
  IO.Put(", j=");
  IO.PutInt(lst);
  IO.Put(") = ");

  RETURN max;

END CalcMaxSubSeq;

BEGIN
  InitSeq(seq);
  IO.Put("Maximale Teilfolge: ");
  IO.PutInt(CalcMaxSubSeq(seq));
  IO.Put("\n");
END MaxSubSeq.



(* Maximale Teilfolge: S_a(i=1, j=17) = 502 *)
