MODULE Hanoi EXPORTS Main;
IMPORT IO;

VAR N, NofSteps : CARDINAL;

PROCEDURE Move(N : CARDINAL; A, B, C : TEXT; VAR NofSteps : CARDINAL) =
  BEGIN
    IF(N>0) THEN
      Move(N-1,A,C,B,NofSteps);

      INC(NofSteps);

      IO.Put("STEP ");
      IO.PutInt(NofSteps);
      IO.Put(": Bewege Scheibe von ");
      IO.Put(A);
      IO.Put(" nach ");
      IO.Put(C);
      IO.Put("\n");

      Move(N-1,B,A,C,NofSteps);
    END;
  END Move;

BEGIN

  IO.Put("Input number of disks: ");
  N:=IO.GetInt();
  IO.Put("\n");

  NofSteps:=0;
  Move(N,"A","B","C",NofSteps);

END Hanoi.
